theory invoices 
imports
 OCL 
begin 


section {* Importing The Model *}

import_model "invoices.zargo" "invoices.ocl"



text {* 
  which loads the data model and the \acs{ocl} specification of
  our case study. The import of our model takes about 10 seconds and 
  already generates \ldots of conservative definitions and proven 
  theorems. 
 *} 


section {* Proving simple properties *}

text {*
  First we show, that a very simple property of \acs{ocl}: an positive
  Integer is allways defined:
  *}


lemma foo: "\<tau> \<MathOclValid> Product.inv.isNat self \<Longrightarrow> \<tau> \<MathOclValid> \<MathOclIsDefined> Product.stock self"
  apply(frule isDefined_if_valid')
  apply(simp add:  Product.inv.isNat_def)
  done

lemma foo [simp]: "\<tau> \<MathOclValid> \<MathOclIsDefined> (0::('a Integer))"
apply(auto)
done


lemma [simp]: "\<tau> \<MathOclValid> 0\<MathOclLe> (0::('a Integer))"
apply(simp add:OCL_Integer.OclLe_def OclLocalValid_def)
apply(simp add: lift2_def strictify_def)
apply(auto)
prefer 2
apply(simp add: OclTrue_def lift0_def)
apply(unfold Zero_ocl_int_def)
apply(auto simp: OclTrue_def lift0_def)
done


lemmas Product_weakinv = 
weakinvariant1.init_stock_def
Product.weakinvariant1.isNat_def
Product.weakinvariant1.init_id_def
weakinvariant1_def 

lemmas mkProduct_post = 
mkProduct_Boolean.post1_def
mkProduct_Boolean.post1.post_0_def
  mkProduct_Boolean.post1.post_0_def


lemmas supply_post = 
supply_Integer_Boolean.post1_def
supply_Integer_Boolean.post1.post_0_def
  supply_Integer_Boolean.post1.post_0_def

lemmas release_pre = 
release_Integer_Boolean.pre1_def
release_Integer_Boolean.pre1.pre_0_def
release_Integer_Boolean.pre1.pre_0_def


lemma 
  "\<tau> \<MathOclValid>  mkProduct_Boolean.post1 self result 
   \<Longrightarrow> 
   \<tau> \<MathOclValid>  Product.weakinvariant1.weakinvariant1 self"
  apply(simp add: mkProduct_post 
                  Product_weakinv)
  apply(safe)
  apply(ocl_simp, simp)+
  done

lemma implies_false_asumption: "\<tau> \<MathOclValid> \<MathOclNot> \<phi> \<Longrightarrow> \<tau> \<MathOclValid> \<phi>  \<MathOclImplies>  \<psi> "
 by(ocl_simp, simp)


lemma implies_prem: "\<tau> \<MathOclValid> \<phi> \<Longrightarrow> \<tau> \<MathOclValid> \<psi> \<MathOclImplies>  \<phi>"
  by(ocl_simp, simp)

lemma implis_prem: "\<tau> \<MathOclValid> \<phi> \<Longrightarrow> \<tau> \<MathOclValid> \<psi> \<MathOclImplies>  \<phi>"
  apply(unfold OclImplies_def)
  apply(rule or_TRUE_I_core)
  apply(rule disjI2)
  by(assumption)


lemma 
  "
  \<exists> qty self \<tau>.(\<tau>  \<MathOclValid> Product.weakinvariant1.weakinvariant1 self)
  \<and> (\<tau>  \<MathOclValid>  release_Integer_Boolean.pre1 self qty)"
  apply(simp add: release_pre 
                  Product_weakinv)
  apply(rule_tac x="1" in exI)
  apply(rule_tac x=
    "\<lambda> (b,b). (\<HolOclLiftLeft>((OclAny_key.OclAny, oid::oid) ,\<HolOclLiftLeft>noext(Product_key.Product,\<HolOclLiftLeft>1\<HolOclLiftRight>,\<HolOclLiftLeft>1\<HolOclLiftRight>)\<HolOclLiftRight>)\<HolOclLiftRight>)" 
    in exI)
  apply(rule exI)+
  apply(safe)
  apply(simp_all add: level1.invoice.Product.stock_def
                      level0.invoice.Product.stock_def
                      ss_lifting' 
                      localValid2sem Zero_ocl_int_def One_ocl_int_def OclStrongEq_def 
                      OCL_Integer.OclLess_def OCL_Integer.OclLe_def )
done


lemma 
  "\<exists> qty self \<tau>. (\<tau>  \<MathOclValid> Product.weakinvariant1.weakinvariant1 self)
  \<and> (\<tau>  \<MathOclValid>  supply_Integer_Boolean.post1 self qty result)"
  apply(simp add: supply_post 
                  Product_weakinv)
  apply(rule_tac x="0" in exI, simp)
  apply(rule_tac x=
    "\<lambda> (b,b). (\<HolOclLiftLeft>((OclAny_key.OclAny, oid::oid) ,\<HolOclLiftLeft>noext(Product_key.Product,\<HolOclLiftLeft>0\<HolOclLiftRight>,\<HolOclLiftLeft>0\<HolOclLiftRight>)\<HolOclLiftRight>)\<HolOclLiftRight>)"
    in exI)
  apply(rule exI)+
  apply(simp_all add: level1.invoice.Product.stock_def
                      level0.invoice.Product.stock_def
                      level1.invoice.Product.stock_pre_def
                      ss_lifting' 
                      localValid2sem OCL_Integer.Zero_ocl_int_def OclStrongEq_def OCL_Integer.OclLe_def 
)
done



end
